GDAL

- Main Page
- Related Pages
- Classes
- Files
- Download
- Issue Tracker

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
OGRGNMWrappedResultLayer Class Reference

The OGRGNMWrappedResultLayer class for search paths queries results. More...

`#include <gnm.h>`

Inheritance diagram for OGRGNMWrappedResultLayer:

## Public Member Functions
| OGRGNMWrappedResultLayer (GDALDataset *poDS, OGRLayer *poLayer)
| Constructor.
virtual void | ResetReading () override
| Reset feature reading to start on the first feature. More...
virtual OGRFeature * | GetNextFeature () override
| Fetch the next available feature from this layer. More...
virtual OGRErr | SetNextByIndex (GIntBig nIndex) override
| Move read cursor to the nIndex'th feature in the current resultset. More...
virtual OGRFeature * | GetFeature (GIntBig nFID) override
| Fetch a feature by its identifier. More...
virtual OGRFeatureDefn * | GetLayerDefn () override
| Fetch the schema information for this layer. More...
virtual GIntBig | GetFeatureCount (int bForce=TRUE) override
| Fetch the feature count in this layer. More...
virtual int | TestCapability (const char *pszCap) override
| Test if this layer supported the named capability. More...
virtual OGRErr | CreateField (OGRFieldDefn *poField, int bApproxOK=TRUE) override
| Create a new field on a layer. More...
virtual OGRErr | CreateGeomField (OGRGeomFieldDefn *poField, int bApproxOK=TRUE) override
| Create a new geometry field on a layer. More...
virtual const char * | GetFIDColumn () override
| This method returns the name of the underlying database column being used as the FID column, or "" if not supported. More...
virtual const char * | GetGeometryColumn () override
| This method returns the name of the underlying database column being used as the geometry column, or "" if not supported. More...
virtual OGRSpatialReference * | GetSpatialRef () override
| Fetch the spatial reference system for this layer. More...
virtual OGRErr | InsertFeature (OGRFeature *poFeature, const CPLString &soLayerName, int nPathNo, bool bIsEdge)
| Undocumented.
Public Member Functions inherited from OGRLayer
FeatureIterator | begin ()
| Return begin of feature iterator. More...
FeatureIterator | end ()
| Return end of feature iterator. More...
virtual OGRGeometry * | GetSpatialFilter ()
| This method returns the current spatial filter for this layer. More...
virtual void | SetSpatialFilter (OGRGeometry *)
| Set a new spatial filter. More...
virtual void | SetSpatialFilterRect (double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter. More...
virtual void | SetSpatialFilter (int iGeomField, OGRGeometry *)
| Set a new spatial filter. More...
virtual void | SetSpatialFilterRect (int iGeomField, double dfMinX, double dfMinY, double dfMaxX, double dfMaxY)
| Set a new rectangular spatial filter. More...
virtual OGRErr | SetAttributeFilter (const char *)
| Set a new attribute query. More...
OGRErr | SetFeature (OGRFeature *poFeature)
| Rewrite an existing feature. More...
OGRErr | CreateFeature (OGRFeature *poFeature)
| Create and write a new feature within a layer. More...
virtual OGRErr | DeleteFeature (GIntBig nFID)
| Delete feature from layer. More...
virtual const char * | GetName ()
| Return the layer name. More...
virtual OGRwkbGeometryType | GetGeomType ()
| Return the layer geometry type. More...
virtual int | FindFieldIndex (const char *pszFieldName, int bExactMatch)
| Find the index of field in the layer. More...
virtual OGRErr | GetExtent (OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer. More...
virtual OGRErr | GetExtent (int iGeomField, OGREnvelope *psExtent, int bForce=TRUE)
| Fetch the extent of this layer, on the specified geometry field. More...
virtual OGRErr | DeleteField (int iField)
| Delete an existing field on a layer. More...
virtual OGRErr | ReorderFields (int *panMap)
| Reorder all the fields of a layer. More...
virtual OGRErr | AlterFieldDefn (int iField, OGRFieldDefn *poNewFieldDefn, int nFlagsIn)
| Alter the definition of an existing field on a layer. More...
virtual OGRErr | SyncToDisk ()
| Flush pending changes to disk. More...
virtual OGRStyleTable * | GetStyleTable ()
| Returns layer style table. More...
virtual void | SetStyleTableDirectly (OGRStyleTable *poStyleTable)
| Set layer style table. More...
virtual void | SetStyleTable (OGRStyleTable *poStyleTable)
| Set layer style table. More...
virtual OGRErr | StartTransaction ()
| For datasources which support transactions, StartTransaction creates a transaction. More...
virtual OGRErr | CommitTransaction ()
| For datasources which support transactions, CommitTransaction commits a transaction. More...
virtual OGRErr | RollbackTransaction ()
| For datasources which support transactions, RollbackTransaction will roll back a datasource to its state before the start of the current transaction. More...
virtual OGRErr | SetIgnoredFields (const char **papszFields)
| Set which fields can be omitted when retrieving features from the layer. More...
OGRErr | Intersection (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Intersection of two layers. More...
OGRErr | Union (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Union of two layers. More...
OGRErr | SymDifference (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions, GDALProgressFunc pfnProgress, void *pProgressArg)
| Symmetrical difference of two layers. More...
OGRErr | Identity (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Identify the features of this layer with the ones from the identity layer. More...
OGRErr | Update (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Update this layer with features from the update layer. More...
OGRErr | Clip (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Clip off areas that are not covered by the method layer. More...
OGRErr | Erase (OGRLayer *pLayerMethod, OGRLayer *pLayerResult, char **papszOptions=nullptr, GDALProgressFunc pfnProgress=nullptr, void *pProgressArg=nullptr)
| Remove areas that are covered by the method layer. More...
int | Reference ()
| Increment layer reference count. More...
int | Dereference ()
| Decrement layer reference count. More...
int | GetRefCount () const
| Fetch reference count. More...
OGRErr | ReorderField (int iOldFieldPos, int iNewFieldPos)
| Reorder an existing field on a layer. More...
Public Member Functions inherited from GDALMajorObject
int | GetMOFlags () const
| Returns the GMO_ flags. More...
void | SetMOFlags (int nFlagsIn)
| Assign GMO_flags. More...
virtual const char * | GetDescription () const
| Fetch object description. More...
virtual void | SetDescription (const char *)
| Set object description. More...
virtual char ** | GetMetadataDomainList ()
| Fetch list of metadata domains. More...
virtual char ** | GetMetadata (const char *pszDomain="")
| Fetch metadata. More...
virtual CPLErr | SetMetadata (char **papszMetadata, const char *pszDomain="")
| Set metadata. More...
virtual const char * | GetMetadataItem (const char *pszName, const char *pszDomain="")
| Fetch single metadata item. More...
virtual CPLErr | SetMetadataItem (const char *pszName, const char *pszValue, const char *pszDomain="")
| Set single metadata item. More...

## Protected Member Functions
virtual OGRErr | ISetFeature (OGRFeature *poFeature) override
| Rewrite an existing feature. More...
virtual OGRErr | ICreateFeature (OGRFeature *poFeature) override
| Create and write a new feature within a layer. More...
Protected Member Functions inherited from GDALMajorObject
char ** | BuildMetadataDomainList (char **papszList, int bCheckNonEmpty,...) CPL_NULL_TERMINATED
| Helper function for custom implementations of GetMetadataDomainList() More...

## Additional Inherited Members
Static Public Member Functions inherited from OGRLayer
static OGRLayerH | ToHandle (OGRLayer *poLayer)
| Convert a OGRLayer* to a OGRLayerH. More...
static OGRLayer * | FromHandle (OGRLayerH hLayer)
| Convert a OGRLayerH to a OGRLayer*. More...
Static Public Member Functions inherited from GDALMajorObject
static GDALMajorObjectH | ToHandle (GDALMajorObject *poMajorObject)
| Convert a GDALMajorObject* to a GDALMajorObjectH. More...
static GDALMajorObject * | FromHandle (GDALMajorObjectH hMajorObject)
| Convert a GDALMajorObjectH to a GDALMajorObject*. More...

## Detailed Description

The OGRGNMWrappedResultLayer class for search paths queries results.

Since
  GDAL 2.1

## Member Function Documentation

OGRErr OGRGNMWrappedResultLayer::CreateField | ( | OGRFieldDefn * | poField,
|  | int | bApproxOK = `TRUE`
| ) |  |
| override virtual

Create a new field on a layer.

You must use this to create new fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this method. You can query a layer to check if it supports it with the OLCCreateField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

Drivers may or may not support not-null constraints. If they support creating fields with not-null constraints, this is generally before creating any feature to the layer.

This function is the same as the C function OGR_L_CreateField().

Parameters

  poField | field definition to write to disk.
  bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns
  OGRERR_NONE on success.

Reimplemented from OGRLayer.

OGRErr OGRGNMWrappedResultLayer::CreateGeomField | ( | OGRGeomFieldDefn * | poField,
|  | int | bApproxOK = `TRUE`
| ) |  |
| override virtual

Create a new geometry field on a layer.

You must use this to create new geometry fields on a real layer. Internally the OGRFeatureDefn for the layer will be updated to reflect the new field. Applications should never modify the OGRFeatureDefn used by a layer directly.

This method should not be called while there are feature objects in existence that were obtained or created with the previous layer definition.

Not all drivers support this method. You can query a layer to check if it supports it with the OLCCreateGeomField capability. Some drivers may only support this method while there are still no features in the layer. When it is supported, the existing features of the backing file/database should be updated accordingly.

Drivers may or may not support not-null constraints. If they support creating fields with not-null constraints, this is generally before creating any feature to the layer.

This function is the same as the C function OGR_L_CreateGeomField().

Parameters

  poField | geometry field definition to write to disk.
  bApproxOK | If TRUE, the field may be created in a slightly different form depending on the limitations of the format driver.

Returns
  OGRERR_NONE on success.

Since
  OGR 1.11

Reimplemented from OGRLayer.

OGRFeature * OGRGNMWrappedResultLayer::GetFeature | ( | GIntBig | nFID | ) |
| override virtual

Fetch a feature by its identifier.

This function will attempt to read the identified feature. The nFID value cannot be OGRNullFID. Success or failure of this operation is unaffected by the spatial or attribute filters (and specialized implementations in drivers should make sure that they do not take into account spatial or attribute filters).

If this method returns a non-NULL feature, it is guaranteed that its feature id (OGRFeature::GetFID()) will be the same as nFID.

Use OGRLayer::TestCapability(OLCRandomRead) to establish if this layer supports efficient random access reading via GetFeature(); however, the call should always work if the feature exists as a fallback implementation just scans all the features in the layer looking for the desired feature.

Sequential reads (with GetNextFeature()) are generally considered interrupted by a GetFeature() call.

The returned feature should be free with OGRFeature::DestroyFeature().

This method is the same as the C function OGR_L_GetFeature().

Parameters

  nFID | the feature id of the feature to read.

Returns
  a feature now owned by the caller, or NULL on failure.

Reimplemented from OGRLayer.

GIntBig OGRGNMWrappedResultLayer::GetFeatureCount | ( | int | bForce = `TRUE` | ) |
| override virtual

Fetch the feature count in this layer.

Returns the number of features in the layer. For dynamic databases the count may not be exact. If bForce is FALSE, and it would be expensive to establish the feature count a value of -1 may be returned indicating that the count isn't know. If bForce is TRUE some implementations will actually scan the entire layer once to count objects.

The returned count takes the spatial filter into account.

Note that some implementations of this method may alter the read cursor of the layer.

This method is the same as the C function OGR_L_GetFeatureCount().

Note: since GDAL 2.0, this method returns a GIntBig (previously a int)

Parameters

  bForce | Flag indicating whether the count should be computed even if it is expensive.

Returns
  feature count, -1 if count not known.

Reimplemented from OGRLayer.

const char * OGRGNMWrappedResultLayer::GetFIDColumn | ( |  | ) |
| override virtual

This method returns the name of the underlying database column being used as the FID column, or "" if not supported.

This method is the same as the C function OGR_L_GetFIDColumn().

Returns
  fid column name.

Reimplemented from OGRLayer.

const char * OGRGNMWrappedResultLayer::GetGeometryColumn | ( |  | ) |
| override virtual

This method returns the name of the underlying database column being used as the geometry column, or "" if not supported.

For layers with multiple geometry fields, this method only returns the name of the first geometry column. For other columns, use GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(i)->GetNameRef().

This method is the same as the C function OGR_L_GetGeometryColumn().

Returns
  geometry column name.

Reimplemented from OGRLayer.

OGRFeatureDefn * OGRGNMWrappedResultLayer::GetLayerDefn | ( |  | ) |
| override virtual

Fetch the schema information for this layer.

The returned OGRFeatureDefn is owned by the OGRLayer, and should not be modified or freed by the application. It encapsulates the attribute schema of the features of the layer.

This method is the same as the C function OGR_L_GetLayerDefn().

Returns
  feature definition.

Implements OGRLayer.

OGRFeature * OGRGNMWrappedResultLayer::GetNextFeature | ( |  | ) |
| override virtual

Fetch the next available feature from this layer.

The returned feature becomes the responsibility of the caller to delete with OGRFeature::DestroyFeature(). It is critical that all features associated with an OGRLayer (more specifically an OGRFeatureDefn) be deleted before that layer/datasource is deleted.

Only features matching the current spatial filter (set with SetSpatialFilter()) will be returned.

This method implements sequential access to the features of a layer. The ResetReading() method can be used to start at the beginning again.

Features returned by GetNextFeature() may or may not be affected by concurrent modifications depending on drivers. A guaranteed way of seeing modifications in effect is to call ResetReading() on layers where GetNextFeature() has been called, before reading again. Structural changes in layers (field addition, deletion, ...) when a read is in progress may or may not be possible depending on drivers. If a transaction is committed/aborted, the current sequential reading may or may not be valid after that operation and a call to ResetReading() might be needed.

This method is the same as the C function OGR_L_GetNextFeature().

Returns
  a feature, or NULL if no more features are available.

Implements OGRLayer.

OGRSpatialReference * OGRGNMWrappedResultLayer::GetSpatialRef | ( |  | ) |
| override virtual

Fetch the spatial reference system for this layer.

The returned object is owned by the OGRLayer and should not be modified or freed by the application.

Starting with OGR 1.11, several geometry fields can be associated to a feature definition. Each geometry field can have its own spatial reference system, which is returned by OGRGeomFieldDefn::GetSpatialRef(). OGRLayer::GetSpatialRef() is equivalent to GetLayerDefn()->OGRFeatureDefn::GetGeomFieldDefn(0)->GetSpatialRef()

This method is the same as the C function OGR_L_GetSpatialRef().

Returns
  spatial reference, or NULL if there isn't one.

Reimplemented from OGRLayer.

OGRErr OGRGNMWrappedResultLayer::ICreateFeature | ( | OGRFeature * | poFeature | ) |
| override protected virtual

Create and write a new feature within a layer.

This method is implemented by drivers and not called directly. User code should use CreateFeature() instead.

The passed feature is written to the layer as a new feature, rather than overwriting an existing one. If the feature has a feature id other than OGRNullFID, then the native implementation may use that as the feature id of the new feature, but not necessarily. Upon successful return the passed feature will have been updated with the new feature id.

Parameters

  poFeature | the feature to write to disk.

Returns
  OGRERR_NONE on success.

Since
  GDAL 2.0

Reimplemented from OGRLayer.

OGRErr OGRGNMWrappedResultLayer::ISetFeature | ( | OGRFeature * | poFeature | ) |
| override protected virtual

Rewrite an existing feature.

This method is implemented by drivers and not called directly. User code should use SetFeature() instead.

This method will write a feature to the layer, based on the feature id within the OGRFeature.

Parameters

  poFeature | the feature to write.

Returns
  OGRERR_NONE if the operation works, otherwise an appropriate error code (e.g OGRERR_NON_EXISTING_FEATURE if the feature does not exist).

Since
  GDAL 2.0

Reimplemented from OGRLayer.

void OGRGNMWrappedResultLayer::ResetReading | ( |  | ) |
| override virtual

Reset feature reading to start on the first feature.

This affects GetNextFeature().

This method is the same as the C function OGR_L_ResetReading().

Implements OGRLayer.

OGRErr OGRGNMWrappedResultLayer::SetNextByIndex | ( | GIntBig | nIndex | ) |
| override virtual

Move read cursor to the nIndex'th feature in the current resultset.

This method allows positioning of a layer such that the GetNextFeature() call will read the requested feature, where nIndex is an absolute index into the current result set. So, setting it to 3 would mean the next feature read with GetNextFeature() would have been the 4th feature to have been read if sequential reading took place from the beginning of the layer, including accounting for spatial and attribute filters.

Only in rare circumstances is SetNextByIndex() efficiently implemented. In all other cases the default implementation which calls ResetReading() and then calls GetNextFeature() nIndex times is used. To determine if fast seeking is available on the current layer use the TestCapability() method with a value of OLCFastSetNextByIndex.

This method is the same as the C function OGR_L_SetNextByIndex().

Parameters

  nIndex | the index indicating how many steps into the result set to seek.

Returns
  OGRERR_NONE on success or an error code.

Reimplemented from OGRLayer.

int OGRGNMWrappedResultLayer::TestCapability | ( | const char * | pszCap | ) |
| override virtual

Test if this layer supported the named capability.

The capability codes that can be tested are represented as strings, but #defined constants exists to ensure correct spelling. Specific layer types may implement class specific capabilities, but this can't generally be discovered by the caller.

- OLCRandomRead / "RandomRead": TRUE if the GetFeature() method is implemented in an optimized way for this layer, as opposed to the default implementation using ResetReading() and GetNextFeature() to find the requested feature id.

- OLCSequentialWrite / "SequentialWrite": TRUE if the CreateFeature() method works for this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCRandomWrite / "RandomWrite": TRUE if the SetFeature() method is operational on this layer. Note this means that this particular layer is writable. The same OGRLayer class may returned FALSE for other layer instances that are effectively read-only.

- OLCFastSpatialFilter / "FastSpatialFilter": TRUE if this layer implements spatial filtering efficiently. Layers that effectively read all features, and test them with the OGRFeature intersection methods should return FALSE. This can be used as a clue by the application whether it should build and maintain its own spatial index for features in this layer.

- OLCFastFeatureCount / "FastFeatureCount": TRUE if this layer can return a feature count (via GetFeatureCount()) efficiently. i.e. without counting the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastGetExtent / "FastGetExtent": TRUE if this layer can return its data extent (via GetExtent()) efficiently, i.e. without scanning all the features. In some cases this will return TRUE until a spatial filter is installed after which it will return FALSE.

- OLCFastSetNextByIndex / "FastSetNextByIndex": TRUE if this layer can perform the SetNextByIndex() call efficiently, otherwise FALSE.

- OLCCreateField / "CreateField": TRUE if this layer can create new fields on the current layer using CreateField(), otherwise FALSE.

- OLCCreateGeomField / "CreateGeomField": (GDAL >= 1.11) TRUE if this layer can create new geometry fields on the current layer using CreateGeomField(), otherwise FALSE.

- OLCDeleteField / "DeleteField": TRUE if this layer can delete existing fields on the current layer using DeleteField(), otherwise FALSE.

- OLCReorderFields / "ReorderFields": TRUE if this layer can reorder existing fields on the current layer using ReorderField() or ReorderFields(), otherwise FALSE.

- OLCAlterFieldDefn / "AlterFieldDefn": TRUE if this layer can alter the definition of an existing field on the current layer using AlterFieldDefn(), otherwise FALSE.

- OLCDeleteFeature / "DeleteFeature": TRUE if the DeleteFeature() method is supported on this layer, otherwise FALSE.

- OLCStringsAsUTF8 / "StringsAsUTF8": TRUE if values of OFTString fields are assured to be in UTF-8 format. If FALSE the encoding of fields is uncertain, though it might still be UTF-8.

- OLCTransactions / "Transactions": TRUE if the StartTransaction(), CommitTransaction() and RollbackTransaction() methods work in a meaningful way, otherwise FALSE.

- OLCIgnoreFields / "IgnoreFields": TRUE if fields, geometry and style will be omitted when fetching features as set by SetIgnoredFields() method.

- OLCCurveGeometries / "CurveGeometries": TRUE if this layer supports writing curve geometries or may return such geometries. (GDAL 2.0).

This method is the same as the C function OGR_L_TestCapability().

Parameters

  pszCap | the name of the capability to test.

Returns
  TRUE if the layer has the requested capability, or FALSE otherwise. OGRLayers will return FALSE for any unrecognized capabilities.

Implements OGRLayer.

The documentation for this class was generated from the following files:

- gnm.h
- gnmresultlayer.cpp